'======================================================================================================================
' NAME: Dell Openmanage E-Mail Alerts
'
' AUTHOR: Paul Murana
' DATE  : 11/03/2010
'
' The Script can be called with three different options:
' DellAlerts.vbs setup - Will automatically add alerts to OMSA
' DellAlerts.vbs testemail - Will send a test e-mail so you can check if mail config is correct.
' DellAlerts.vbs email X - Where X is a number that corresponds to a Dell alert, this is how OMSA will send its alert.
'======================================================================================================================
' 
'======================================================================================================================

EmailFrom	=""	'Set the from E-Mail Address
EmailTo		=""	'Set the E-Mail address to send alerts to
SMTPServer	=""	'Specify remote SMTP server or leave blank to send through local machine
SMTPPort	="25"	'Specify remote SMTP server port, default is 25
SMTPUser	=""	'Specify SMTP Username or leave blank for no authentication
SMTPPass	=""	'Specify SMTP Password for SMTP Auth
MailSubject	="Dell Server Alert on [COMPUTERNAME] - " 'Edit the subject to your liking [COMPUTERNAME] will automatically be replaced with the actual computername

Dim AlertConfig(38)
AlertConfig(0)="powersupply|Power supply failure"
AlertConfig(1)="powersupplywarn|Power supply warning"
AlertConfig(2)="tempwarn|Temperature warning"
AlertConfig(3)="tempfail|Temperature failure"
AlertConfig(4)="fanwarn|Fan speed warning"
AlertConfig(5)="fanfail|Fan speed failure"
AlertConfig(6)="voltwarn|Voltage warning"
AlertConfig(7)="voltfail|Voltage failure"
AlertConfig(8)="intrusion|Chassis intrusion"
AlertConfig(9)="redundegrad|Redundancy degraded"
AlertConfig(10)="redunlost|Redundancy lost"
AlertConfig(11)="memprefail|Nemory pre-failure"
AlertConfig(12)="memfail|Memory failure"
AlertConfig(13)="hardwarelogwarn|Hardware log warning"
AlertConfig(14)="hardwarelogfull|Hardware log full"
AlertConfig(15)="processorwarn|Processor warning"
AlertConfig(16)="processorfail|Processor failure"
AlertConfig(17)="watchdogasr|Watchdog asr"
AlertConfig(18)="batterywarn|Battery warning"
AlertConfig(19)="batteryfail|Battery failure"
AlertConfig(20)="systempowerwarn|Power warning"
AlertConfig(21)="systempowerfail|Power failure"
AlertConfig(22)="systempeakpower|Peak power"
AlertConfig(23)="removableflashmediapresent|Removable flash media present"
AlertConfig(24)="removableflashmediaremoved|Removable flash media removed"
AlertConfig(25)="removableflashmediafail|Removable flash media failure"
AlertConfig(26)="storagesyswarn|Storage System warning"
AlertConfig(27)="storagesysfail|Storage System failure"
AlertConfig(28)="storagectrlwarn|Storage Controller warning"
AlertConfig(29)="storagectrlfail|Storage Controller failure"
AlertConfig(30)="pdiskwarn|Physical Disk warning"
AlertConfig(31)="pdiskfail|Physical Disk failure"
AlertConfig(32)="vdiskwarn|Virtual Disk warning"
AlertConfig(33)="vdiskfail|Virtual Disk failure"
AlertConfig(34)="enclosurewarn|Enclosure warning"
AlertConfig(35)="enclosurefail|Enclosure failure"
AlertConfig(36)="storagectrlbatterywarn|Storage Controller Battery warning"
AlertConfig(37)="storagectrlbatteryfail|Storage Controller Battery failure"

Set oShell 		= CreateObject( "WScript.Shell" )
computername		= oShell.ExpandEnvironmentStrings("%ComputerName%")
Set oShell = nothing

Args=WScript.Arguments.Count
If Args > 0 Then
	Action = trim(lcase(WScript.Arguments.Item(0)))
	Select Case Action
	Case "setup"
		For i = 0 To ubound(AlertConfig)
			If AlertConfig(i) <> "" then
				AlertDetails=Split(AlertConfig(i),"|")
				SetDellAlert AlertDetails(0), i
			End If
		Next
	Case "email" 
		AlertDetails=Split(AlertConfig(WScript.Arguments.Item(1)), "|")
		MailSubject = Replace(MailSubject, "[COMPUTERNAME]", computername)
 		MailSubject = Mailsubject & AlertDetails(1)
		SendAlert MailSubject
	Case "testemail"
		MailSubject = Replace(MailSubject, "[COMPUTERNAME]", computername)
		MailSubject = Mailsubject & "Test Alert"
		SendAlert MailSubject
	End select
End If

Sub SendAlert(Subject)
		Set objMessage 		= CreateObject("CDO.Message") 
		objMessage.From 	= EmailFrom
		objMessage.To 		= EmailTo
		objMessage.Subject	= Subject
		If SMTPServer = "" Then SMTPServer = "localhost"

    	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2 
		objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserver") = SMTPServer
		objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = SMTPPort

		If SMTPUser <> "" Then
			objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusername") = SMTPUser
			objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendpassword") = SMTPPass
			objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1
		End If
		
		objMessage.Configuration.Fields.Update
		objMessage.Send	
End Sub

Sub SetDellAlert(DellEvent, EventID)
	cmd="omconfig system alertaction event=" & DellEvent & " execappath=" & Chr(34) & WScript.FullName & " \" & chr(34) & WScript.ScriptFullName & "\" & chr(34) &  " email " & EventID & Chr(34)
	Set WshShell = WScript.CreateObject("WScript.Shell")
	WshShell.run cmd,1,true
End Sub
